<?php
/*
Plugin Name: GigaTools Widget
Plugin URI: http://www.berryplasman.com/wordpress/gigatools-widget
Description: Shows your GigaTools in a widget in your sidebar.
Author: Beee
Version: 0.2.1
Author URI: http://www.berryplasman.com
License: GPLv2 (or later)

Copyright 2011-2014 Beee (email : info@berryplasman.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

/**
 * GGT Widget Class
 */
class GGTWidget extends WP_Widget {
    /** constructor */
    function GGTWidget() {
        parent::WP_Widget(false, $name = 'GigaTools Widget');	
    }

    /** @see WP_Widget::widget */
    function widget($args, $instance) {		
        extract( $args );
        $ggt_widgettitle 	= apply_filters('widget_title', $instance['ggt_widgettitle']);
				$ggt_usergroup 		= $instance['ggt_usergroup'];
        $ggt_username 		= $instance['ggt_username'];
        $ggt_artist 			= $instance['ggt_artist'];
				$ggt_font 				= $instance['ggt_font'];
				$ggt_bgcolor 			= $instance['ggt_bgcolor'];
				$ggt_linkcolor 		= $instance['ggt_linkcolor'];
				$ggt_bodycolor 		= $instance['ggt_bodycolor'];
				$ggt_maxgigs 			= $instance['ggt_maxgigs'];
				$ggt_showmore 		= $instance['ggt_showmore'];
				$ggt_bookinglink 	= $instance['ggt_bookinglink'];
				$ggt_showbooking 	= $instance['ggt_showbooking'];
				$ggt_subscribe 		= $instance['ggt_subscribe'];
				// $ggt_showrss 			= $instance['ggt_showrss'];
				// $ggt_showical 		= $instance['ggt_showical'];
				$ggt_showlogo 		= $instance['ggt_showlogo'];
				echo $before_widget; 
				if ( $ggt_widgettitle ) echo $before_title . $ggt_widgettitle . $after_title;
?>
				<div id="____gigawidget"></div>
				<?php echo "<script type=\"text/javascript\">____gigawidget_config={\"client\":\"" . $ggt_usergroup . "\", \"id\":\"" . $ggt_username . "\", \"ca\":\"" . $ggt_bgcolor . "\", \"cb\":\"" . $ggt_linkcolor . "\", \"cc\":\"" . $ggt_bodycolor . "\", \"maxrows\":\"" . $ggt_maxgigs . "\"};</script>"; ?>
				<?php if ( $ggt_showlogo || $ggt_showmore || $ggt_showbooking || $ggt_subscribe ) { ?>
				<div class="ggt_belowwidget">
					<?php if ( $ggt_showlogo ) { ?><div class="ggt_powered"><a href="http://www.gigatools.com" target="_blank"><?php echo '<img src="' . plugins_url( 'assets/img/footer-gigatools.png', __FILE__ ) . '" alt="GigaTools" />'; ?></a></div><?php } ?>
					<?php if ( $ggt_showmore ) { ?><div class="ggt_moredates"><a href="http://gigs.gigatools.com/user/<?php echo $ggt_username; ?>" target="_blank" style="font-family:<?php echo $ggt_font; ?>; color:#<?php echo $ggt_linkcolor; ?>; text-decoration: none;" title="Click here for more dates for <?php if ( $ggt_artist ) { echo $ggt_artist; } else { echo $ggt_username; } ?>">Click here for all dates</a></div><?php } ?>
					<?php if ( $ggt_showbooking ) { ?><div class="ggt_bookinglink"><a href="<?php echo $ggt_bookinglink; ?>" target="_blank" style="font-family:<?php echo $ggt_font; ?>; color:#<?php echo $ggt_linkcolor; ?>; text-decoration: none;" title="Click here to book <?php if ( $ggt_artist ) { echo $ggt_artist; } else { echo $ggt_username; } ?>">Click here to book <?php if ( $ggt_artist ) { echo $ggt_artist; } else { echo $ggt_username; } ?></a></div><?php } ?>
					<?php if ( $ggt_subscribe ) { ?><div class="ggt_sublinks" style="font-family:<?php echo $ggt_font; ?>; color:#<?php echo $ggt_linkcolor; ?>;"><a href="http://gigs.gigatools.com/user/<?php echo $ggt_username; ?>.rss" target="_blank" style="font-family:<?php echo $ggt_font; ?>; color:#<?php echo $ggt_linkcolor; ?>; text-decoration: none;">RSS</a> / <a href="http://gigs.gigatools.com/user/<?php echo $ggt_username; ?>show.ics" target="_blank" style="font-family:<?php echo $ggt_font; ?>; color:#<?php echo $ggt_linkcolor; ?>; text-decoration: none;">iCal</a></div><?php } ?>
				</div>
        <?php } 
        	echo $after_widget; ?>
        <?php
    }

    /** @see WP_Widget::update */
    function update($new_instance, $old_instance) {				
			$instance = $old_instance;
			$instance['ggt_widgettitle'] 	= strip_tags($new_instance['ggt_widgettitle']);
			$instance['ggt_usergroup'] 		= strip_tags($new_instance['ggt_usergroup']);
			$instance['ggt_username'] 		= strip_tags($new_instance['ggt_username']);
			$instance['ggt_artist'] 			= strip_tags($new_instance['ggt_artist']);
			$instance['ggt_font'] 				= strip_tags($new_instance['ggt_font']);
			$instance['ggt_bgcolor'] 			= strip_tags($new_instance['ggt_bgcolor']);
			$instance['ggt_linkcolor'] 		= strip_tags($new_instance['ggt_linkcolor']);
			$instance['ggt_bodycolor'] 		= strip_tags($new_instance['ggt_bodycolor']);
			$instance['ggt_maxgigs'] 			= strip_tags($new_instance['ggt_maxgigs']);
			$instance['ggt_showmore'] 		= strip_tags($new_instance['ggt_showmore']);
			$instance['ggt_bookinglink'] 	= strip_tags($new_instance['ggt_bookinglink']);
			$instance['ggt_showbooking'] 	= strip_tags($new_instance['ggt_showbooking']);
			$instance['ggt_subscribe'] 		= strip_tags($new_instance['ggt_subscribe']);
			$instance['ggt_showlogo'] 		= strip_tags($new_instance['ggt_showlogo']);
	    return $instance;
    }

    /** @see WP_Widget::form */
    function form($instance) {				
        $ggt_widgettitle 	= esc_attr($instance['ggt_widgettitle']);
        $ggt_usergroup 		= esc_attr($instance['ggt_usergroup']);
        $ggt_username 		= esc_attr($instance['ggt_username']);
        $ggt_artist 			= esc_attr($instance['ggt_artist']);
        $ggt_font 				= esc_attr($instance['ggt_font']);
        $ggt_bgcolor 			= esc_attr($instance['ggt_bgcolor']);
        $ggt_linkcolor 		= esc_attr($instance['ggt_linkcolor']);
        $ggt_bodycolor 		= esc_attr($instance['ggt_bodycolor']);
        $ggt_maxgigs 			= esc_attr($instance['ggt_maxgigs']);
        $ggt_showmore 		= esc_attr($instance['ggt_showmore']);
        $ggt_bookinglink 	= $instance['ggt_bookinglink'];
        $ggt_showbooking 	= $instance['ggt_showbooking'];
        $ggt_subscribe 		= $instance['ggt_subscribe'];
        $ggt_showlogo 		= esc_attr($instance['ggt_showlogo']);
        ?>
        <p>
          <label for="<?php echo $this->get_field_id('ggt_widgettitle'); ?>">Widget title:</label> 
          <input class="widefat" id="<?php echo $this->get_field_id('ggt_widgettitle'); ?>" name="<?php echo $this->get_field_name('ggt_widgettitle'); ?>" type="text" value="<?php if ( $ggt_widgettitle ) { echo $ggt_widgettitle; } ?>" />
        </p>
        <p>
          <label for="<?php echo $this->get_field_id('ggt_usergroup'); ?>"><?php _e('User or Group (lowercase only):'); ?></label>
          <input class="widefat" id="<?php echo $this->get_field_id('ggt_usergroup'); ?>" name="<?php echo $this->get_field_name('ggt_usergroup'); ?>" type="text" value="<?php if ( $ggt_usergroup ) { echo $ggt_usergroup; } else { echo "user"; } ?>" />
        </p>
        <p>
          <label for="<?php echo $this->get_field_id('ggt_username'); ?>"><?php _e('Username:'); ?></label> 
          <input class="widefat" id="<?php echo $this->get_field_id('ggt_username'); ?>" name="<?php echo $this->get_field_name('ggt_username'); ?>" type="text" value="<?php if ( $ggt_username ) { echo $ggt_username; } ?>" />
        </p>
        <p>
          <label for="<?php echo $this->get_field_id('ggt_artist'); ?>"><?php _e('Artist name:'); ?></label> 
          <input class="widefat" id="<?php echo $this->get_field_id('ggt_artist'); ?>" name="<?php echo $this->get_field_name('ggt_artist'); ?>" type="text" value="<?php if ( $ggt_artist ) { echo $ggt_artist; } ?>" />
        </p>
        <p>
          <label for="<?php echo $this->get_field_id('ggt_font'); ?>"><?php _e('Widget font:'); ?></label> 
          <input class="widefat" id="<?php echo $this->get_field_id('ggt_font'); ?>" name="<?php echo $this->get_field_name('ggt_font'); ?>" type="text" value="<?php if ( $ggt_font ) { echo $ggt_font; } ?>" />
        </p>
        <p>
          <label for="<?php echo $this->get_field_id('ggt_bgcolor'); ?>"><?php _e('Background color:'); ?></label> 
          <input class="widefat" id="<?php echo $this->get_field_id('ggt_bgcolor'); ?>" name="<?php echo $this->get_field_name('ggt_bgcolor'); ?>" type="text" value="<?php if ( $ggt_bgcolor ) { echo $ggt_bgcolor; } ?>" />
        </p>
        <p>
          <label for="<?php echo $this->get_field_id('ggt_linkcolor'); ?>"><?php _e('Link color:'); ?></label> 
          <input class="widefat" id="<?php echo $this->get_field_id('ggt_linkcolor'); ?>" name="<?php echo $this->get_field_name('ggt_linkcolor'); ?>" type="text" value="<?php if ( $ggt_linkcolor ) { echo $ggt_linkcolor; } ?>" />
        </p>
        <p>
          <label for="<?php echo $this->get_field_id('ggt_bodycolor'); ?>"><?php _e('Text color:'); ?></label> 
          <input class="widefat" id="<?php echo $this->get_field_id('ggt_bodycolor'); ?>" name="<?php echo $this->get_field_name('ggt_bodycolor'); ?>" type="text" value="<?php if ( $ggt_bodycolor ) { echo $ggt_bodycolor; } ?>" />
        </p>
        <p>
          <label for="<?php echo $this->get_field_id('ggt_maxgigs'); ?>"><?php _e('Max. # of Gigs:'); ?></label> 
          <input class="widefat" id="<?php echo $this->get_field_id('ggt_maxgigs'); ?>" name="<?php echo $this->get_field_name('ggt_maxgigs'); ?>" type="text" value="<?php if ( $ggt_maxgigs ) { echo $ggt_maxgigs; } ?>" />
        </p>

        <p>
          <label for="<?php echo $this->get_field_id('ggt_showmore'); ?>"><?php _e('Show link to all dates:'); ?></label>          
          <input class="" id="<?php echo $this->get_field_id('ggt_showmore'); ?>" name="<?php echo $this->get_field_name('ggt_showmore'); ?>" type="checkbox" value="show booking" <?php if ( $ggt_showmore ) { echo "checked"; } ?> />
        </p>

        <p>
          <label for="<?php echo $this->get_field_id('ggt_bookinglink'); ?>"><?php _e('Booking link:'); ?></label> 
          <input class="widefat" id="<?php echo $this->get_field_id('ggt_bookinglink'); ?>" name="<?php echo $this->get_field_name('ggt_bookinglink'); ?>" type="text" value="<?php if ( $ggt_bookinglink ) { echo $ggt_bookinglink; } ?>" />
        </p>
        <p>
          <label for="<?php echo $this->get_field_id('ggt_showbooking'); ?>"><?php _e('Show GigaTools Bookingslink:'); ?></label>          
          <input class="" id="<?php echo $this->get_field_id('ggt_showbooking'); ?>" name="<?php echo $this->get_field_name('ggt_showbooking'); ?>" type="checkbox" value="show booking" <?php if ( $ggt_showbooking ) { echo "checked"; } ?> />
        </p>
        <p>
          <label for="<?php echo $this->get_field_id('ggt_subscribe'); ?>"><?php _e('Show Follow Links:'); ?></label>          
          <input class="" id="<?php echo $this->get_field_id('ggt_subscribe'); ?>" name="<?php echo $this->get_field_name('ggt_subscribe'); ?>" type="checkbox" value="show follow" <?php if ( $ggt_subscribe ) { echo "checked"; } ?> />
        </p>
        <p>
          <label for="<?php echo $this->get_field_id('ggt_showlogo'); ?>"><?php _e('Show GigaTools Logo:'); ?></label>          
          <input class="" id="<?php echo $this->get_field_id('ggt_showlogo'); ?>" name="<?php echo $this->get_field_name('ggt_showlogo'); ?>" type="checkbox" value="show logo" <?php if ( $ggt_showlogo ) { echo "checked"; } ?> />
        </p>
        <p>
        	<a href="<?php echo site_url(); ?>/wp-admin/options-general.php?page=ggt-help">Click here for the F.A.Q.</a>
        </p>
        <?php 
    }

} // class GGTWidget

/**
 * Register GGTWidget widget
 */
add_action('widgets_init', create_function('', 'return register_widget("GGTWidget");'));

/**
 * Enqueues jQuery.min.js, GigaWidget.js and CSS
 */
if (!is_admin()) add_action('wp_enqueue_scripts', 'ggt_scripts', 12);
function ggt_scripts() {
	wp_deregister_script('jquery');
	wp_register_script('jquery', "http" . ($_SERVER['SERVER_PORT'] == 443 ? "s" : "") . "://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js", false, null);
	wp_enqueue_script('jquery');

	wp_register_script( 'gigawidget', plugins_url('assets/js/GigaWidget.js', __FILE__), array('jquery') );
	wp_enqueue_script('gigawidget');

	wp_register_style( 'ggt-css', plugins_url('assets/css/style-front.css', __FILE__) );
	wp_enqueue_style( 'ggt-css' );
}

/**
 * Enqueues CSS for the admin
 */
if (is_admin()) add_action('admin_enqueue_scripts', 'ggt_admincss');
function ggt_admincss() {
	wp_register_style( 'ggt-admincss', plugins_url('assets/css/style-admin.css', __FILE__) );
	wp_enqueue_style( 'ggt-admincss' );
}

/**
 * Adds a page in settings menu
 */
add_action( 'admin_menu', 'ggt_menu' );
function ggt_menu() {
 	global $ggt_plugin_hook;
 	$ggt_plugin_hook = add_options_page( 'GigaTools Help', 'GigaTools', 'manage_options', 'ggt-help', 'ggt_help' );
}

/**
 * Adds contextual help (for future use)
 */
function ggt_plugin_help($contextual_help, $screen_id, $screen) {
	global $ggt_plugin_hook;
	if ($screen_id == $ggt_plugin_hook) {
		$contextual_help = '<p>This is where I would provide help to the user on how everything in my admin panel works. Formatted HTML works fine in here too.</p>';
	}
	return $contextual_help;
}
// add_filter('contextual_help', 'ggt_plugin_help', 10, 3);

/**
 * Content for page in Settings menu
 */
function ggt_help() {
	if ( !current_user_can('manage_options') )  {
		wp_die( __('You do not have sufficient permissions to access this page.') );
	}
	// global $ggt_username, $ggt_widgettitle, $ggt_height, $ggt_width, $ggt_font, $ggt_bgcolor, $ggt_titlecolor, $ggt_bodycolor, $ggt_maxgigs, $ggt_showmore, $ggt_bookinglink, $ggt_showbooking, $ggt_subscribe, $ggt_showlogo;

?>
	<div class="wrap">
		<h2>Help | GigaTools</h2>
		<p>On this page you can find some helpful info about your GigaTools Widget.
			<br />
			It explains all fields/options which can be entered/ticked/modified.
			<br /><br />
			In a future version this will also be the settings page, instead of in the widget itself.
		</p>
		<div class="admin_left">				
			<ul>
				<li>
					<h3>Widget title</h3>
					<p>Field can be empty but advisable is to use a title.<br />Default: empty</p>
				</li>
				<li>
					<h3>User or Group</h3>
					<p>Must be all lowercase.<br />Default: user</p>
				</li>
				<li>
					<h3>Username</h3>
					<p>Can be empty but nothing will show then.<br />Default: empty</p>
				</li>
				<li>
					<h3>Artistname</h3>
					<p>This is used for the bookingslink and for the text when hovering over links.<br />Note: if you activate the bookingslink and don't enter an artistname, the username will be used instead.<br />Default: empty</p>
				</li>
				<li>
					<h3>Font</h3>
					<p>Enter a font here to override your own font.<br />Default: none (defined by your template's css)</p>
				</li>
				<li>
					<h3>Background</h3>
					<p>Enter a hex color code here (without the #).<br />Default: none (defined by your template's css)</p>
				</li>
				<li>
					<h3>Link color</h3>
					<p>Color for the links below the widget.<br />Default: none (defined by your template's css)</p>
				</li>
				<li>
					<h3>Text color</h3>
					<p>Color of the text.<br />Default: none (defined by your template's css)</p>
				</li>
				<li>
					<h3>Number of gigs</h3>
					<p>Default: none (minimum of 5 is advised)</p>
				</li>
				<li>
					<h3>Show all dates</h3>
					<p>Opens your GGT page in a new window, if selected.<br />Default: unchecked</p>
				</li>
				<li>
					<h3>Booking link</h3>
					<p>This must be either a link to a web address (http://) or a mail adress (mailto:).<br />Default: empty</p>
				</li>
				<li>
					<h3>Show booking</h3>
					<p>Shows/hides the links to a booking option.<br />Default: unchecked</p>
				</li>
				<li>
					<h3>Show follow links</h3>
					<p>Shows/hides the links to subscribe to RSS or iCal.<br />Default: unchecked</p>
				</li>
				<li>
					<h3>Show logo</h3>
					<p>Shows/hides the logo/link to GigaTools.<br />Default: unchecked</p></p>
				</li>
			</ul>	
		</div>
		<div class="admin_right">
			<?php include('assets/inc/sidebar.php'); ?>
		</div>
	</div>
<?php } 
?>